//@author: antokhio
//@help: template for geometry shaders
//@tags: GS, template
//@credits:

float4x4 tW : WORLD;
float4x4 tVP : VIEWPROJECTION;

struct VS_IN
{
	uint iv : SV_VertexID;
};

struct VS_OUT
{
	uint iv : TEXCOORD0;
};

struct GS_OUT
{
	float4 pos : SV_Position;
	//float4 uv : TEXCOORD0;
};

StructuredBuffer<float4> position;

VS_OUT VS(VS_IN input)
{
    return input;
}

[maxvertexcount(3)]
void GS(triangle VS_OUT input[3], inout TriangleStream<GS_OUT> gsout)
{
	GS_OUT output;

	for (int i = 0 ; i < 3 ; i ++)
	{
		uint idx = input[i].iv;
		
		output.pos = mul (position[idx], mul (tW, tVP));
		//output.uv = input[i].uv;
		gsout.Append(output);
	}
	gsout.RestartStrip();
}

float4 PS(GS_OUT input): SV_Target
{
    return 1;
}

technique10 Template
{
    pass P0
    {
        SetVertexShader( CompileShader( vs_4_0, VS() ) );
        SetGeometryShader( CompileShader( gs_4_0, GS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
    }  
}